import type { JSX } from '../../stencil-public-runtime';
import type { AutoCompletePropType, DisabledPropType, FocusableElement, HasCounterPropType, HideLabelPropType, HideMsgPropType, HintPropType, IconsHorizontalPropType, InputEmailAPI, InputEmailStates, InputTypeOnDefault, InternalButtonProps, KolFocusOptions, LabelWithExpertSlotPropType, MaxLengthBehaviorPropType, MsgPropType, MultiplePropType, NamePropType, PlaceholderPropType, ReadOnlyPropType, RequiredPropType, ShortKeyPropType, Stringified, SuggestionsPropType, SyncValueBySelectorPropType, TooltipAlignPropType, VariantClassNamePropType } from '../../schema';
export declare class KolInputEmail implements InputEmailAPI, FocusableElement {
    protected readonly host?: HTMLKolInputEmailElement;
    protected readonly ctaRef: import("../../utils/element-interaction").CtaRef<HTMLInputElement>;
    getValue(): Promise<string | undefined>;
    focus(options?: KolFocusOptions): Promise<void>;
    click(): Promise<void>;
    private readonly onKeyDown;
    private readonly onInput;
    private getFormFieldProps;
    private getInputProps;
    render(): JSX.Element;
    private readonly controller;
    _accessKey?: string;
    _autoComplete?: AutoCompletePropType;
    _hasCounter?: boolean;
    _maxLengthBehavior?: MaxLengthBehaviorPropType;
    _disabled?: boolean;
    _hideMsg?: boolean;
    _hideLabel?: boolean;
    _hint?: string;
    _icons?: IconsHorizontalPropType;
    _label: LabelWithExpertSlotPropType;
    _maxLength?: number;
    _msg?: Stringified<MsgPropType>;
    _multiple?: boolean;
    _name?: NamePropType;
    _on?: InputTypeOnDefault;
    _pattern?: string;
    _placeholder?: string;
    _readOnly?: boolean;
    _required?: boolean;
    _shortKey?: ShortKeyPropType;
    _smartButton?: Stringified<InternalButtonProps>;
    _suggestions?: SuggestionsPropType;
    _syncValueBySelector?: SyncValueBySelectorPropType;
    _tooltipAlign?: TooltipAlignPropType;
    _touched?: boolean;
    _value?: string;
    _variant?: VariantClassNamePropType;
    state: InputEmailStates;
    private inputHasFocus;
    constructor();
    private showAsAlert;
    validateAccessKey(value?: string): void;
    validateAutoComplete(value?: AutoCompletePropType): void;
    validateDisabled(value?: DisabledPropType): void;
    validateHideMsg(value?: HideMsgPropType): void;
    validateHideLabel(value?: HideLabelPropType): void;
    validateHasCounter(value?: HasCounterPropType): void;
    validateHint(value?: HintPropType): void;
    validateIcons(value?: IconsHorizontalPropType): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateMaxLength(value?: number): void;
    validateMsg(value?: Stringified<MsgPropType>): void;
    validateMultiple(value?: MultiplePropType): void;
    validateName(value?: string): void;
    validateOn(value?: InputTypeOnDefault): void;
    validatePattern(value?: string): void;
    validatePlaceholder(value?: PlaceholderPropType): void;
    validateReadOnly(value?: ReadOnlyPropType): void;
    validateRequired(value?: RequiredPropType): void;
    validateShortKey(value?: ShortKeyPropType): void;
    validateSuggestions(value?: SuggestionsPropType): void;
    validateSmartButton(value?: InternalButtonProps | string): void;
    validateSyncValueBySelector(value?: SyncValueBySelectorPropType): void;
    validateTouched(value?: boolean): void;
    validateValue(value?: string): void;
    validateMaxLengthBehavior(value?: MaxLengthBehaviorPropType): void;
    validateVariant(value?: VariantClassNamePropType): void;
    componentWillLoad(): void;
}
